package model;

import sll.SinglyLinkedList;

/*
 * Strategy 1: List front is treated as the front of queue.
 */

public class LinkedQueue<E> implements Queue<E> {
	private SinglyLinkedList<E> data;
	
	public LinkedQueue() {
		data = new SinglyLinkedList<>(); 
	} 
	
	public int size() { 
		return data.size(); 
	} 
	
	public boolean isEmpty() { 
		return size() == 0; 
	} 
	
	public E first() {
		if (isEmpty()) { 
			throw new IllegalArgumentException("Empty Queue"); 
		}
		else { 
			return data.getFirst(); 
		} 
	}
	
	public void enqueue(E e) {
		data.addLast(e); 
	}
	
	public E dequeue() {
		if (isEmpty()) { 
			throw new IllegalArgumentException("Empty Queue"); 
		}
		else { 
			E result;
			result = first(); 
			data.removeFirst();
			return result;
		}
	}
}